import os
from pathlib import Path
import logging
import shutil
import subprocess
from typing import NamedTuple
from multiprocessing import Pool

logger = logging.getLogger(__name__)


class Task(NamedTuple):
    cmd: str
    output_tmp: Path
    output_path: Path


def _run_task(args):
    task = args[0]

    subprocess.run(cmd, shell=True)
    os.makedirs(task.output_path.parent, exist_ok=True)
    shutil.move(task.output_tmp, task.output_path)


def run_tasks(tasks, pool_size: 10):
    with Pool(10) as p:
        p.map(_run_task, tasks)
